﻿package com.identityMine.documentClass
{
	
	import flash.display.MovieClip;
	
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;
	
	import flash.display.Stage;
	
	import CELL;
	
	public class DocumentClass extends MovieClip
	{
		// Variables related to cell spacing
				
		// how much we want to shift it right
		var shift_right = 50;
		// how much we want to shift it down
		var shift_down = 50;
		// how much space between columns
		var spread_apart = 75;
		// how much space between rows
		var spead_down = 75;
		// how many columns we want
		var columns = 10;
		// how many rows we want
		var rows = 10;
				
		var CellArray : Array = new Array();
		
		public function DocumentClass(){
			// I start at the top left, and build down.
			// After I build an entire column, then I move to the right and build down again
			for (var i = 0; i < columns; i++){
				for (var j = 0; j < rows; j++){

					var _cell : CELL;
				
					// create the cell
					_cell = new CELL();
					_cell.SetStage(stage);
					_cell.SetIJ(i, j);
					
					// set some of the values I need for each cell
					_cell.setRowsColumns(rows, columns);
					
					// shift it down
					_cell.y = _cell.y + j * spead_down + shift_down;
					
					// shift it apart
					_cell.x = _cell.x + i * spread_apart + shift_right;
				
					_cell.scaleX = 0.05;
					_cell.scaleY = 0.05;
					
					

					
					// Add the cell to the cell list
					CellArray.push(_cell);
					// Add the cell to the screen
					addChild(_cell);
					
					// if I make our cells aware of the cell array, they receive a complete reference to it, 
					// even if it is not completely filled our right now...
					CellArray[i * columns + j].setNodeList(CellArray);
					
					} // end for j
				} // end for i
				
				
				
				// Make our adjacency list
				GenerateAdjacencyList();
				
				// visualizeHelper();
				// AdjacencyListChecker();
				
		} // end DocumentClass() constructor
		
		private function GenerateAdjacencyList(){
		// Iteration to add everything to the adjacency list
			
			for (var i = 0; i < columns; i++){
				for (var j = 0; j < rows; j++){
					//var _cell : CELL = CellArray[i * columns + j];
					
					if (i < columns - 1){
						CellArray[i * columns + j].AddArrow(CellArray[(i + 1 )* columns + j]);
					}
					
					if (i > 0){
						CellArray[i * columns + j].AddArrow(CellArray[(i - 1) * columns + j]);
					}
										
					if (j > 0){
						CellArray[i * columns + j].AddArrow(CellArray[(i * columns) + j - 1]);
					}
					
					if (j < rows - 1){
						CellArray[i * columns + j].AddArrow(CellArray[(i * columns + j + 1)]);
					}
										
				} // end for j
				
			}// end for i
				
			
		} // end GenerateAdjacencyList()

		
		
		private function visualizeHelper(){
			/*
			// A helpful routine for visualizing how the array is layed out
			*/
			
			// Our cell
			CellArray[1 * 10 + 2].test();
			// CellArray[i * 10 + j]
			
			// One above our cell				
			CellArray[1 * 10 + 1].test2(); 
			// CellArray[i * columns + j - 1 ]
				
			// One to the left of our cell
			CellArray[0 * 10 + 2].test2();
			// CellArray[(i - 1) * columns + j]
				
			// One to the right of our cell
			CellArray[2 * 10 + 2].test2();
			// CellArray[(i + 1) * columns + j]
				
			// One below our cell
			CellArray[1 * 10 + 3].test2();
			// CellArray[i * columns + j + 1]

		} // end visualizeHelper()
		
		private function AdjacencyListChecker(){
			// This method goes through and calculates the number of nodes that have 2, 3, and 4 elements in their adjacency list
			// This is to make sure I am calculating everything correctly.
			
			var twos : int = 0;
			var threes : int = 0;
			var fours : int = 0;
			
			for (var i = 0; i < columns; i++){
					for (var j = 0; j < rows; j++){
						
						// We should only have 4 elements with 2 items in their adjacency list, these are the four corners
						if (CellArray[i * columns + j].EdgeList.length == 2){
							twos = twos + 1;
						}
						
						// For threes, we have 2 * (rows - 2) + 2 * (columns - 2)
						// since we have the top and bottom row, minus their two corners PLUS
						//     two for the right and left column, minus their two corners
						if (CellArray[i * columns + j].EdgeList.length == 3){
							threes = threes + 1;
						}
						
						if (CellArray[i * columns + j].EdgeList.length == 4){
							fours = fours + 1;
						}
						
					} // end for j
			} // end for i
		
			trace("two's = " + twos);
			trace("three's = " + threes);
			var sum : int = (2 * (rows - 2)) + (2 * (columns - 2));
			trace("   (2 * (rows - 2)) + (2 * (columns - 2)) = " + sum + "(what threes should be)");
			trace("fours = " + fours);
			sum = (rows - 2) * (columns - 2);
			trace ("(rows - 2) * (columns - 2) = " + sum + "(what fours should be)");
		
		} // end AdjacencyListChecker()
		
	} // end class DocumentClass
	
} // end package